---
title: Instrumentation
aliases:
- /docs/tempo/latest/guides/instrumentation/
weight: 100
---

# References to use when instrumenting your applications 

Check out these resources for help instrumenting tracing with your favorite languages.  Most of these guides include complete end to end examples with Grafana, Loki, and Tempo. 

## OpenTelemetry

- [OpenTelemetry Language Specific Instrumentation](https://opentelemetry.io/docs/)

## Jaeger 
- [Jaeger Language Specific Instrumentation](https://www.jaegertracing.io/docs/latest/client-libraries/)

## Zipkin 
- [Zipkin Language Specific Instrumentation](https://zipkin.io/pages/tracers_instrumentation.html)

## Grafana Blog

- [Java Spring Boot Auto-Instrumentation](https://grafana.com/blog/2021/02/03/auto-instrumenting-a-java-spring-boot-application-for-traces-and-logs-using-opentelemetry-and-grafana-tempo/)
- [Go + OpenMetrics Exemplars](https://grafana.com/blog/2020/11/09/trace-discovery-in-grafana-tempo-using-prometheus-exemplars-loki-2.0-queries-and-more/)
- [.NET](https://grafana.com/blog/2021/02/11/instrumenting-a-.net-web-api-using-opentelemetry-tempo-and-grafana-cloud/)
- [Python](https://grafana.com/blog/2021/05/04/get-started-with-distributed-tracing-and-grafana-tempo-using-foobar-a-demo-written-in-python/)

## Community Resources

- [NodeJS](https://github.com/mnadeem/nodejs-opentelemetry-tempo)
- [Java Spring Boot](https://github.com/mnadeem/boot-opentelemetry-tempo)
- [Python](https://github.com/dgzlopes/foobar-demo)
